import { Injector } from '@opensumi/di';
import { Event, Emitter, Uri, FileSystemProviderCapabilities } from '@opensumi/ide-core-common';
import { IDiskFileProvider, FileChangeEvent, FileSystemProvider, DidFilesChangedParams } from '../common';
export declare abstract class CoreFileServiceProviderClient implements FileSystemProvider {
    injector: Injector;
    abstract capabilities: FileSystemProviderCapabilities;
    abstract onDidChangeCapabilities: Event<void>;
    abstract fileServiceProvider: FileSystemProvider;
    protected readonly onDidChangeFileEmitter: Emitter<FileChangeEvent>;
    onDidChangeFile: Event<FileChangeEvent>;
    watch(uri: Uri, options: {
        recursive: boolean;
        excludes: string[];
    }): number | Promise<number>;
    unwatch(watcherId: number): void | Promise<void> | undefined;
    stat(uri: Uri): Promise<void | import("@opensumi/ide-core-common").FileStat>;
    readDirectory(uri: Uri): [string, import("@opensumi/ide-core-common").FileType][] | Promise<[string, import("@opensumi/ide-core-common").FileType][]>;
    createDirectory(uri: Uri): void | Promise<void | import("@opensumi/ide-core-common").FileStat>;
    readFile(uri: Uri, encoding?: string): Promise<void | Uint8Array>;
    writeFile(uri: Uri, content: Uint8Array, options: {
        create: boolean;
        overwrite: boolean;
    }): void | Thenable<void | import("@opensumi/ide-core-common").FileStat>;
    delete(uri: Uri, options: {
        recursive: boolean;
        moveToTrash?: boolean | undefined;
    }): void | Promise<void>;
    rename(oldUri: Uri, newUri: Uri, options: {
        overwrite: boolean;
    }): void | Promise<void | import("@opensumi/ide-core-common").FileStat>;
}
export declare class DiskFsProviderClient extends CoreFileServiceProviderClient implements IDiskFileProvider {
    fileServiceProvider: IDiskFileProvider;
    onDidChangeCapabilities: Event<void>;
    protected _capabilities: FileSystemProviderCapabilities | undefined;
    get capabilities(): FileSystemProviderCapabilities;
    setWatchFileExcludes(excludes: string[]): void | Thenable<void>;
    getWatchFileExcludes(): string[] | Thenable<string[]>;
    onDidFilesChanged(event: DidFilesChangedParams): void;
    copy(source: Uri, destination: Uri, options: {
        overwrite: boolean;
    }): void | Thenable<void | import("@opensumi/ide-core-common").FileStat>;
    access(uri: Uri, mode: number): Promise<boolean>;
    getCurrentUserHome(): Promise<import("@opensumi/ide-core-common").FileStat | undefined>;
    getFileType(uri: string): Promise<string | undefined>;
}
//# sourceMappingURL=file-service-provider-client.d.ts.map