"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileServiceClientModule = void 0;
const tslib_1 = require("tslib");
const di_1 = require("@opensumi/di");
const ide_core_browser_1 = require("@opensumi/ide-core-browser");
const index_1 = require("../common/index");
const file_service_client_1 = require("./file-service-client");
const file_service_contribution_1 = require("./file-service-contribution");
const file_service_provider_client_1 = require("./file-service-provider-client");
const shadow_file_system_provider_1 = require("./shadow-file-system.provider");
let FileServiceClientModule = class FileServiceClientModule extends ide_core_browser_1.BrowserModule {
    constructor() {
        super(...arguments);
        this.providers = [
            {
                token: index_1.IFileServiceClient,
                useClass: file_service_client_1.FileServiceClient,
            },
            {
                token: index_1.IBrowserFileSystemRegistry,
                useClass: file_service_client_1.BrowserFileSystemRegistryImpl,
            },
            {
                token: index_1.IDiskFileProvider,
                useClass: file_service_provider_client_1.DiskFsProviderClient,
            },
            {
                token: index_1.IShadowFileProvider,
                useClass: shadow_file_system_provider_1.ShadowFileSystemProvider,
            },
            file_service_contribution_1.FileServiceContribution,
        ];
        // 依赖 fileService 服务
        this.backServices = [
            {
                servicePath: index_1.DiskFileServicePath,
                clientToken: index_1.IDiskFileProvider,
            },
        ];
    }
};
FileServiceClientModule = tslib_1.__decorate([
    (0, di_1.Injectable)()
], FileServiceClientModule);
exports.FileServiceClientModule = FileServiceClientModule;
//# sourceMappingURL=index.js.map