"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShadowFileSystemProvider = void 0;
const tslib_1 = require("tslib");
const di_1 = require("@opensumi/di");
const ide_core_browser_1 = require("@opensumi/ide-core-browser");
let ShadowFileSystemProvider = class ShadowFileSystemProvider {
    constructor() {
        this.capabilities = 2048 /* FileSystemProviderCapabilities.Readonly */;
        this.onDidChangeCapabilities = ide_core_browser_1.Event.None;
        this.readonly = true;
        this.shadowFiles = new Map();
        this.fileChangeEmitter = new ide_core_browser_1.Emitter();
        this.onDidChangeFile = this.fileChangeEmitter.event;
    }
    watch(uri, options) {
        throw new Error('Method not implemented.');
    }
    stat(uri) {
        return Promise.resolve({
            uri: uri.toString(),
            lastModification: 0,
        });
    }
    readDirectory(uri) {
        throw new Error('Method not implemented.');
    }
    createDirectory(uri) {
        throw new Error('Method not implemented.');
    }
    readFile(uri) {
        const content = this.shadowFiles.get(uri.toString());
        return content || ide_core_browser_1.BinaryBuffer.fromString('no available').buffer;
    }
    writeFile(uri, content, options) {
        this.shadowFiles.set(uri.toString(), content);
    }
    delete(uri, options) {
        throw new Error('Method not implemented.');
    }
    rename(oldUri, newUri, options) {
        throw new Error('Method not implemented.');
    }
    copy(source, destination, options) {
        throw new Error('Method not implemented.');
    }
    exists(uri) {
        throw new Error('Method not implemented.');
    }
    access(uri, mode) {
        throw new Error('Method not implemented.');
    }
};
ShadowFileSystemProvider = tslib_1.__decorate([
    (0, di_1.Injectable)()
], ShadowFileSystemProvider);
exports.ShadowFileSystemProvider = ShadowFileSystemProvider;
//# sourceMappingURL=shadow-file-system.provider.js.map