"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileServiceModule = exports.getFileservice = void 0;
const tslib_1 = require("tslib");
const di_1 = require("@opensumi/di");
const ide_core_node_1 = require("@opensumi/ide-core-node");
const common_1 = require("../common");
const disk_file_system_provider_1 = require("./disk-file-system.provider");
const file_service_1 = require("./file-service");
tslib_1.__exportStar(require("./file-service"), exports);
const fsInstanceMap = new Map();
function getFileservice(injector, providerToken) {
    if (fsInstanceMap.get(injector)) {
        return fsInstanceMap.get(injector);
    }
    const fileService = injector.get(providerToken);
    fsInstanceMap.set(injector, fileService);
    return fileService;
}
exports.getFileservice = getFileservice;
let FileServiceModule = class FileServiceModule extends ide_core_node_1.NodeModule {
    constructor() {
        super(...arguments);
        this.providers = [
            { token: common_1.IFileService, useFactory: (injector) => (0, file_service_1.getSafeFileservice)(injector) },
            { token: common_1.IDiskFileProvider, useFactory: (injector) => getFileservice(injector, disk_file_system_provider_1.DiskFileSystemProvider) },
        ];
        this.backServices = [
            {
                servicePath: common_1.DiskFileServicePath,
                token: common_1.IDiskFileProvider,
            },
            {
                servicePath: common_1.ShadowFileServicePath,
                token: common_1.IShadowFileProvider,
            },
            {
                servicePath: common_1.FileServicePath,
                token: common_1.IFileService,
            },
        ];
    }
};
FileServiceModule = tslib_1.__decorate([
    (0, di_1.Injectable)()
], FileServiceModule);
exports.FileServiceModule = FileServiceModule;
//# sourceMappingURL=index.js.map